#include <stdio.h>
#include <stdlib.h>

#include "../util.h"

char *jescape(char *s)
{
	int i;
	char *ptr;
	size_t size;
	FILE *stream;
	if (!(stream = open_memstream(&ptr, &size)))
		exit(99);
	for (; *s; s ++)
		switch (*s)
		{
			case '"':
				fputs("\\\"", stream); break;
			case '\\':
				fputs("\\\\", stream); break;
			case '\b':
				fputs("\\b", stream); break;
			case '\f':
				fputs("\\f", stream); break;
			case '\n':
				fputs("\\n", stream); break;
			case '\r':
				fputs("\\r", stream); break;
			case '\t':
				fputs("\\t", stream); break;
			default:
				if (*s <= 0x1f)
					fprintf(stream, "\\u%04x", *s);
				else
					fputc(*s, stream);
		}
	fclose(stream);
	return ptr;
}
